<script setup lang="ts">
import { computed, onMounted, reactive, ref, type Ref } from 'vue'


import { useSalaryStore } from '@/stores/salary'
import { useAuthStore } from '@/stores/auth'
import { useBranchStore } from '@/stores/branch';


const branchStore = useBranchStore()
const salaryStore = useSalaryStore()
const authStore = useAuthStore()

const selectedBranchId = ref(null)
const startDate = ref(null)
const endDate = ref(null)

const selectedMonth = ref(null) // Reactive variable to store the selected month
const currentUser = authStore.getCurrentUser()
const Currentrole = authStore.getCurrentUser()!.role.name

console.log(selectedBranchId)

// ฟังก์ชัน computed ที่จะคืนค่ารายการเงินเดือนที่ผ่านการกรองตามเงื่อนไขของบทบาทของผู้ใช้
const filteredSalarys = computed(() => {
  if (!currentUser) return [];

  if (Currentrole === 'เจ้าของกิจการ') {
    // กรองข้อมูลทั้งหมดสำหรับเจ้าของกิจการ
    return filterByOwner(salaryStore.salarys.value);
  } else if (Currentrole === 'ผู้จัดการร้าน') {
    // กรองตาม branch และช่วงเวลาสำหรับผู้จัดการร้าน
    return filterByManager(salaryStore.salarys.value);
  } else if (Currentrole === 'พนักงานพาทไทม์' || Currentrole === 'พนักงานทั่วไป') {
    // กรองตาม user id และช่วงเวลาสำหรับพนักงานพาทไทม์และพนักงานทั่วไป
    return filterByEmployee(salaryStore.salarys.value);
  }

  return []; // คืนค่าข้อมูลว่างๆ ในกรณีที่ไม่ตรงกับเงื่อนไขใดๆ
});

function filterByOwner(data: any[]): any[] {
  if (!selectedBranchId.value && !selectedMonth.value) {
    return data.filter((item) => item.status === 'pay');
  } else if (!selectedBranchId.value) {
    return data.filter((item) => item.status === 'pay' && item.month === selectedMonth.value);
  } else if (!selectedMonth.value) {
    return data.filter((item) => item.branch === selectedBranchId.value?.id && item.status === 'pay');
  } else {
    return data.filter((item) => item.branch === selectedBranchId.value?.id && item.status === 'pay' && item.month === selectedMonth.value);
  }
}


function filterByManager(data: any[]): any[] {
  if (!selectedBranchId.value && !selectedMonth.value) {
    return data.filter((item) => item.status === 'pay' && item.branch === currentUser?.branch);
  } else if (!selectedBranchId.value) {
    return data.filter((item) => item.status === 'pay' && item.branch === currentUser?.branch && item.month === selectedMonth.value);
  } else if (!selectedMonth.value) {
    return data.filter((item) => item.status === 'pay' && item.branch === selectedBranchId.value?.id);
  } else {
    return data.filter((item) => item.branch === selectedBranchId.value?.id && item.status === 'pay' && item.month === selectedMonth.value);
  }
}

function filterByEmployee(data: any[]): any[] {
  return data.filter((item) => item.user === currentUser?.id && item.status === 'pay');
}

console.log(filteredSalarys)


let total = ref(0)
onMounted(async () => {
  await branchStore.getBranches()
  await salaryStore.getSalarys()
  await salaryStore.getTotalPay()
  total
})

function formatDate(date: any) {
  if (!date) return ''; // Return empty string if date is not provided
  return new Date(date).toLocaleDateString();
}

</script>

<template>
  <div>
    <v-sheet>
      <v-container fluid>

        <!-- <v-row>
          <v-col cols="12" sm="4">
            <v-card color="#ab9283" class="rounded-xl" height="150">
              <div class="d-flex flex-nowarp justify-space-between">
                <div>
                  <v-card-title class="text-h5 mt-5"> รวมยอดรายวัน </v-card-title>
                  <v-card-subtitle>
                    <template v-if="filteredSalarys.length > 0">
                      Month: {{ formatDate(salaryStore.salarys.value[0]?.payDate) }} | Max Total Payment: {{
                      salaryStore.payment.value[0].TotalPayment }}
                    </template>
                    <template v-else>
                    </template>
                  </v-card-subtitle>
                </div>
              </div>
            </v-card>
          </v-col>

          <v-col cols="12" sm="4">
            <v-card color="#ab9283" class="rounded-xl" height="150">
              <div class="d-flex flex-nowarp justify-space-between">
                <div>
                  <v-card-title class="text-h5 mt-5"> รวมยอดรายเดือน </v-card-title>
                  <v-card-subtitle>{{ }}</v-card-subtitle>
                </div>
              </div>
            </v-card>
          </v-col>

          <v-col cols="12" sm="4">
            <v-card color="#ab9283" class="rounded-xl" height="150">
              <div class="d-flex flex-nowarp justify-space-between">
                <div>
                  <v-card-title class="text-h5 mt-5"> รวมยอดรายปี </v-card-title>
                  <v-card-subtitle>baba</v-card-subtitle>
                </div>
              </div>
            </v-card>
          </v-col>

        </v-row> -->

        <v-row>
          <v-col cols="12" sm="12">
            <v-card class="mx-auto">
              <!-- <v-card-title>Salary Management</v-card-title> -->
              <v-toolbar flat>
                <v-toolbar-title>Payment History</v-toolbar-title>
                <v-divider class="mx-4" inset vertical></v-divider>
                <v-spacer></v-spacer>
              </v-toolbar>

              <v-row>
                <v-card-text style="max-height: 100px" class="mt-4 mr-2 ml-2">
                  <v-row>
                    <v-col cols="12" md="4">
                      <v-select v-model="selectedBranchId" :items="branchStore.branches" item-title="name"
                        item-value="id" return-object clearable density="compact" placeholder="เลือกสาขา"
                        prepend-inner-icon="mdi-awning-outline" variant="outlined" filled rounded
                        bg-color="#ffcb5e"></v-select>
                    </v-col>
                    <v-col cols="12" sm="4">
                      <!-- Start Date Filter -->
                      <v-text-field v-model="startDate" :landscape="true" scrollable actions="actions"
                        placeholder="Start Date" class="mr-2" return-object clearable density="compact" filled rounded
                        variant="outlined" type="date"></v-text-field>
                    </v-col>
                    <v-col cols="12" sm="4">
                      <!-- End Date Filter -->
                      <v-text-field v-model="endDate" :landscape="true" scrollable actions="actions"
                        placeholder="End Date" return-object clearable density="compact" variant="outlined" filled
                        rounded type="date"></v-text-field>
                    </v-col></v-row>
                </v-card-text>
              </v-row>

              <v-table fixed-header height="530">
                <thead>
                  <tr>
                    <th>Id</th>
                    <th>ชื่อ-นามสกุล</th>
                    <th>ตำแหน่ง</th>
                    <th>เดือน</th>
                    <th>จำนวนชั่วโมงรวม</th>
                    <th>ฐานเงินเดือน</th>
                    <th>จำนวนเงินรวม</th>
                    <th>วันที่จ่าย</th>
                    <th>สถานะ</th>
                    <th>ใบเสร็จ</th>
                  </tr>
                </thead>
                <tbody>
                  <tr v-for="item in filteredSalarys" :key="item.id">
                    <td>{{ item.id }}</td>
                    <td>{{ item.fullName }}</td>
                    <td>{{ item.role }}</td>
                    <td>{{ item.month }}</td>
                    <td>{{ item.totalHour }}</td>
                    <td>{{ item.pricePerHour }}</td>
                    <td>{{ item.totalPay }}</td>
                    <td>{{ formatDate(item.payDate) }}</td>
                    <td>{{ item.status }}</td>
                    <td>
                      <v-btn size="30px" prepend-icon="mdi-receipt-text-clock"
                        @click="salaryStore.SlipDialog.value = true">
                      </v-btn>
                    </td>
                  </tr>
                </tbody>
              </v-table>

              <!-- <PaymentSlip></PaymentSlip> -->
              <v-dialog v-model="salaryStore.SlipDialog.value" persistent width="500">
                <v-card class="d-flex align-center justify-center">
                  <v-img src="./img/logo/logo_name_black.png" alt="Logo" width="120px" class="text-center mt-3"></v-img>

                  <v-card-title style="text-align: center; font-size: 20px"><strong>PAY SLIP</strong>
                  </v-card-title>

                  <v-card-text class="info" style="text-align: center; margin-top: 0; padding-top: 5; line-height: 0">
                    ****************************************************************
                  </v-card-text>
                  <v-card-text>
                    <v-row class="info">
                      <v-col style="text-align: center">
                        <v-row>
                          <v-col>Payment ID : {{ salaryStore.selected.value.id }}</v-col>
                        </v-row>
                        <v-row>
                          <v-col>Full Name : {{ salaryStore.selected.value.fullName }}</v-col>
                        </v-row>
                        <v-row>
                          <v-col>Position : {{ salaryStore.selected.value.role }}</v-col>
                        </v-row>
                      </v-col>
                    </v-row>
                    <v-card-text class="info" style="text-align: center; margin-top: 0; padding-top: 5; line-height: 0">
                      ***************************************************************************
                    </v-card-text>
                    <h3 style="text-align: center;"> เงินเดือน </h3>
                    <v-card-text>
                      <v-row style="padding-bottom: 0; text-align: center">
                        <v-col> ฐานเงินเดือน </v-col>
                        <v-col> ชั่วโมงรวมสุทธิ </v-col>
                        <v-col> จำนวนเงินรวม </v-col>
                      </v-row>
                      <v-row style="padding-bottom: 0; text-align: center">
                        <v-col>{{ salaryStore.selected.value.pricePerHour }}</v-col>
                        <v-col>{{ salaryStore.selected.value.totalHour }}</v-col>
                        <v-col>{{ salaryStore.selected.value.totalPay }}</v-col>
                      </v-row>
                    </v-card-text>
                    <v-card-text class="info" style="text-align: center; margin-top: 0; padding-top: 5; line-height: 0">
                      ***************************************************************************
                    </v-card-text>

                    <v-card-text>
                      <v-row>
                        <v-col cols="12" md="12">
                          <v-row>
                            <v-col cols="12" md="6" style="text-align: left" class="info">Pay Date : {{
                              formatDate(salaryStore.selected.value.payDate)
                              }}</v-col>
                            <v-col cols="12" md="6" style="text-align: right" class="info">Payer's Name : {{
                              authStore.getCurrentUser()?.name
                              }}</v-col>
                          </v-row>
                        </v-col>
                      </v-row>
                    </v-card-text>
                  </v-card-text>

                  <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn style="background-color: transparent" variant="text"
                      @click="salaryStore.SlipDialog.value = false">
                      Close
                    </v-btn>
                  </v-card-actions>
                </v-card>
              </v-dialog>
            </v-card>
          </v-col>
        </v-row>
      </v-container>
    </v-sheet>
  </div>
</template>

<style scoped>
.v-sheet {
  background-color: #fff5e8;
}

.v-sheet,
.v-card {
  border-bottom-left-radius: 15px;
  border-bottom-right-radius: 15px;
  border-top-left-radius: 15px;
  border-top-right-radius: 15px;
  text-decoration: none;
}

.v-toolbar {
  border-top-left-radius: 15px;
  border-top-right-radius: 15px;
  text-decoration: none;
  background-color: #ab9283;
}

.v-toolbar-title {
  font-weight: bold;
  font-size: 24px;
  color: white;
}

.v-table {
  border-bottom-left-radius: 15px;
  border-bottom-right-radius: 15px;
  text-decoration: none;
  background-color: #fff5e8;
}

.v-btn {
  background-color: #ffcb5e;
  border-radius: 100px;
}

.info {
  font-size: 14px;
}
</style>
